## mingw-w64-liboqs-0.13.0-1.src.tar.zst

=== CMakeLists.txt ===
# SPDX-License-Identifier: MIT

cmake_minimum_required (VERSION 3.15)
# option() honors normal variables.
# see: https://cmake.org/cmake/help/git-stage/policy/CMP0077.html
if(POLICY CMP0077)
    cmake_policy(SET CMP0077 NEW)
endif()
# Honor symbol visibility properties for all target types.
# see: https://cmake.org/cmake/help/git-stage/policy/CMP0063.html
if(POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif()
if(POLICY CMP0066)
    cmake_policy(SET CMP0066 NEW)
endif()
if(POLICY CMP0067)
    cmake_policy(SET CMP0067 NEW)
endif()

project(liboqs C ASM)

option(OQS_DIST_BUILD "Build distributable library with optimized code for several CPU microarchitectures. Enables run-time CPU feature detection." ON)
option(OQS_BUILD_ONLY_LIB "Build only liboqs and do not expose build targets for tests, documentation, and pretty-printing available." OFF)
set(OQS_MINIMAL_BUILD "" CACHE STRING "Only build specifically listed algorithms.")
option(OQS_LIBJADE_BUILD "Enable formally verified implementation of supported algorithms from libjade." OFF)
option(OQS_PERMIT_UNSUPPORTED_ARCHITECTURE "Permit compilation on an an unsupported architecture." OFF)
option(OQS_STRICT_WARNINGS "Enable all compiler warnings." OFF)
option(OQS_EMBEDDED_BUILD "Compile liboqs for an Embedded environment without a full standard library." OFF)
option(OQS_USE_CUPQC "Utilize cuPQC as the backend for supported PQC algorithms." OFF)

# Libfuzzer isn't supported on gcc
if('${CMAKE_C_COMPILER_ID}' STREQUAL 'Clang')
    option(OQS_BUILD_FUZZ_TESTS "Build fuzz test suite" OFF)
endif()


set(OQS_OPT_TARGET auto CACHE STRING "The target microarchitecture for optimization.")

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(OQS_VERSION_MAJOR 0)
set(OQS_VERSION_MINOR 13)
set(OQS_VERSION_PATCH 0)
set(OQS_VERSION_PRE_RELEASE "")
set(OQS_VERSION_TEXT "${OQS_VERSION_MAJOR}.${OQS_VERSION_MINOR}.${OQS_VERSION_PATCH}${OQS_VERSION_PRE_RELEASE}")
set(OQS_COMPILE_BUILD_TARGET "${CMAKE_SYSTEM_PROCESSOR}-${CMAKE_HOST_SYSTEM}")
set(OQS_MINIMAL_GCC_VERSION "7.1.0")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Determine the flags for fuzzing. Use OSS-Fuzz's configuration if available, otherwise fall back to defaults.
if(DEFINED ENV{LIB_FUZZING_ENGINE})
    set(FUZZING_ENGINE $ENV{LIB_FUZZING_ENGINE})
    set(FUZZING_COMPILE_FLAGS "")
    set(FUZZING_LINK_FLAGS "${FUZZING_ENGINE}")
else()
    set(FUZZING_COMPILE_FLAGS "-fsanitize=fuzzer,address")
    set(FUZZING_LINK_FLAGS "-fsanitize=fuzzer,address")
endif()

# heuristic check to see whether we're running on a RaspberryPi
if(EXISTS "/opt/vc/include/bcm_host.h")
	add_definitions( -DOQS_USE_RASPBERRY_PI )
endif()

if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64|amd64|AMD64")
    set(ARCH "x86_64")
    set(ARCH_X86_64 ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_X86_64_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "x86|i586|i686")
    set(ARCH "i586")
    set(ARCH_X86 ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_X86_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "aarch64|arm64|arm64v8")
    set(ARCH "arm64v8")
    set(ARCH_ARM64v8 ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_ARM64_V8_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "armel|armhf|armv7|arm32v7")
    set(ARCH "arm32v7")
    set(ARCH_ARM32v7 ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_ARM32_V7_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "ppc64le|powerpc64le")
    set(ARCH "ppc64le")
    set(ARCH_PPC64LE ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_PPC64LE_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "(ppc64|powerpc64)")
    message(WARNING "There is currently no CI for: " ${CMAKE_SYSTEM_PROCESSOR})
    set(ARCH "ppc64")
    set(ARCH_PPC64 ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_PPC64_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "(ppc|powerpc)")
    message(WARNING "There is currently no CI for: " ${CMAKE_SYSTEM_PROCESSOR})
    # CMake uses uname to derive CMAKE_SYSTEM_PROCESSOR value, so on Darwin
    # the value is identical for ppc and ppc64. To have the right build arch
    # in 64-bit case, we use CMAKE_OSX_ARCHITECTURES.
    if(APPLE AND CMAKE_OSX_ARCHITECTURES STREQUAL "ppc64")
        set(ARCH "ppc64")
        set(ARCH_PPC64 ON)
        if(${OQS_DIST_BUILD})
            set(OQS_DIST_PPC64_BUILD ON)
        endif()
    else()
        set(ARCH "ppc")
        set(ARCH_PPC ON)
        if(${OQS_DIST_BUILD})
            set(OQS_DIST_PPC_BUILD ON)
        endif()
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "s390x")
    set(ARCH "s390x")
    set(ARCH_S390X ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_S390X_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "riscv")
    set(ARCH "riscv")
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "loongarch64")
    set(ARCH "loongarch64")
    set(ARCH_LOONGARCH64 ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_LOONGARCH64_BUILD ON)
    endif()
elseif(OQS_PERMIT_UNSUPPORTED_ARCHITECTURE)
    message(WARNING "Unknown or unsupported processor: " ${CMAKE_SYSTEM_PROCESSOR})
    message(WARNING "Compilation on an unsupported processor should only be used for testing, as it may result an insecure configuration, for example due to variable-time instructions leaking secret information.")
else()
    message(FATAL_ERROR "Unknown or unsupported processor: " ${CMAKE_SYSTEM_PROCESSOR} ". Override by setting OQS_PERMIT_UNSUPPORTED_ARCHITECTURE=ON")
endif()

if(${OQS_USE_CUPQC})
    # CMAKE's CUDA language requires CMAKE 3.18
    cmake_minimum_required (VERSION 3.18)
    enable_language(CUDA)
    if(NOT DEFINED CMAKE_CUDA_ARCHITECTURES)
      set(CMAKE_CUDA_ARCHITECTURES 80 90)
    endif()
    find_package(cuPQC 0.2.0 REQUIRED)
endif()

if (NOT ((CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin") AND (ARCH_X86_64 STREQUAL "ON")) AND (OQS_LIBJADE_BUILD STREQUAL "ON"))
    message(FATAL_ERROR "Building liboqs with libjade implementations from libjade is only supported on Linux and Darwin on x86_64.")
endif()

# intentionally don't switch to variables to avoid --warn-uninitialized report
if(OQS_USE_CPU_EXTENSIONS)
    message(FATAL_ERROR "OQS_USE_CPU_EXTENSIONS is deprecated")
endif()

# intentionally don't switch to variables to avoid --warn-uninitialized report
if(OQS_PORTABLE_BUILD)
    message(FATAL_ERROR "OQS_PORTABLE_BUILD is deprecated")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
    set(OQS_DEBUG_BUILD ON)
else()
    set(OQS_DEBUG_BUILD OFF)
endif()

option(OQS_SPEED_USE_ARM_PMU "Use ARM Performance Monitor Unit during benchmarking" OFF)

if(WIN32 AND NOT (MINGW OR MSYS OR CYGWIN))
    set(CMAKE_GENERATOR_CC cl)
endif()

include(.CMake/compiler_opts.cmake)
include(.CMake/alg_support.cmake)

if(${OQS_USE_OPENSSL})
    if(NOT DEFINED OPENSSL_ROOT_DIR)
        if(${CMAKE_HOST_SYSTEM_NAME} STREQUAL "Darwin")
            if(EXISTS "/usr/local/opt/openssl@1.1")
                set(OPENSSL_ROOT_DIR "/usr/local/opt/openssl@1.1")
            elseif(EXISTS "/opt/homebrew/opt/openssl@1.1")
                set(OPENSSL_ROOT_DIR "/opt/homebrew/opt/openssl@1.1")
            endif()
        endif()
    endif()
    find_package(OpenSSL 1.1.1 REQUIRED)

    if(OQS_DLOPEN_OPENSSL)
      find_program(OBJDUMP objdump)
      if(NOT OBJDUMP)
	message(FATAL_ERROR "objdump not found. Please install it from binutils.")
      endif()
      execute_process(
	COMMAND ${OBJDUMP} -p ${OPENSSL_CRYPTO_LIBRARY}
	COMMAND sed -n "s/[ 	]\\{1,\\}SONAME[ 	]\\{1,\\}//p"
	OUTPUT_VARIABLE OQS_OPENSSL_CRYPTO_SONAME
	OUTPUT_STRIP_TRAILING_WHITESPACE
	COMMAND_ERROR_IS_FATAL ANY)
      message(STATUS "OpenSSL dlopen SONAME: " ${OQS_OPENSSL_CRYPTO_SONAME})
    endif()
endif()

set(PUBLIC_HEADERS ${PROJECT_SOURCE_DIR}/src/oqs.h
                   ${PROJECT_SOURCE_DIR}/src/common/aes/aes_ops.h
                   ${PROJECT_SOURCE_DIR}/src/common/common.h
                   ${PROJECT_SOURCE_DIR}/src/common/rand/rand.h
                   ${PROJECT_SOURCE_DIR}/src/common/sha2/sha2_ops.h
                   ${PROJECT_SOURCE_DIR}/src/common/sha3/sha3_ops.h
                   ${PROJECT_SOURCE_DIR}/src/common/sha3/sha3x4_ops.h
                   ${PROJECT_SOURCE_DIR}/src/kem/kem.h
                   ${PROJECT_SOURCE_DIR}/src/sig/sig.h
                   ${PROJECT_SOURCE_DIR}/src/sig_stfl/sig_stfl.h)

set(INTERNAL_HEADERS ${PROJECT_SOURCE_DIR}/src/common/aes/aes.h
                     ${PROJECT_SOURCE_DIR}/src/common/rand/rand_nist.h
                     ${PROJECT_SOURCE_DIR}/src/common/sha2/sha2.h
                     ${PROJECT_SOURCE_DIR}/src/common/sha3/sha3.h
                     ${PROJECT_SOURCE_DIR}/src/common/sha3/sha3x4.h)

if(${OQS_ENABLE_KEM_BIKE})
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/bike/kem_bike.h)
endif()
if(${OQS_ENABLE_KEM_FRODOKEM})
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/frodokem/kem_frodokem.h)
endif()
if(OQS_ENABLE_KEM_NTRUPRIME)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/ntruprime/kem_ntruprime.h)
endif()
##### OQS_COPY_FROM_UPSTREAM_FRAGMENT_INCLUDE_HEADERS_START
if(OQS_ENABLE_KEM_CLASSIC_MCELIECE)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/classic_mceliece/kem_classic_mceliece.h)
endif()
if(OQS_ENABLE_KEM_HQC)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/hqc/kem_hqc.h)
endif()
if(OQS_ENABLE_KEM_KYBER)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/kyber/kem_kyber.h)
endif()
if(OQS_ENABLE_KEM_ML_KEM)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/ml_kem/kem_ml_kem.h)
endif()
if(OQS_ENABLE_SIG_DILITHIUM)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/dilithium/sig_dilithium.h)
endif()
if(OQS_ENABLE_SIG_ML_DSA)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/ml_dsa/sig_ml_dsa.h)
endif()
if(OQS_ENABLE_SIG_FALCON)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/falcon/sig_falcon.h)
endif()
if(OQS_ENABLE_SIG_SPHINCS)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/sphincs/sig_sphincs.h)
endif()
if(OQS_ENABLE_SIG_MAYO)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/mayo/sig_mayo.h)
endif()
if(OQS_ENABLE_SIG_CROSS)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/cross/sig_cross.h)
endif()
if(OQS_ENABLE_SIG_UOV)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/uov/sig_uov.h)
endif()
##### OQS_COPY_FROM_UPSTREAM_FRAGMENT_INCLUDE_HEADERS_END
if(OQS_ENABLE_SIG_STFL_XMSS)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig_stfl/xmss/sig_stfl_xmss.h)
endif()
if(OQS_ENABLE_SIG_STFL_LMS)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig_stfl/lms/sig_stfl_lms.h)
endif()
execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory ${PROJECT_BINARY_DIR}/include/oqs)
execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${PUBLIC_HEADERS} ${PROJECT_BINARY_DIR}/include/oqs)
execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${INTERNAL_HEADERS} ${PROJECT_BINARY_DIR}/include/oqs)
configure_file(src/oqsconfig.h.cmake ${PROJECT_BINARY_DIR}/include/oqs/oqsconfig.h)
set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_BINARY_DIR}/include/oqs/oqsconfig.h)

include_directories(${PROJECT_BINARY_DIR}/include)
add_subdirectory(src)

if(NOT ${OQS_BUILD_ONLY_LIB})
    add_subdirectory(tests)

    if (NOT CYGWIN)
      find_package(Doxygen)
      if(DOXYGEN_FOUND)
        set(DOXYFILE ${PROJECT_SOURCE_DIR}/docs/.Doxyfile)
        add_custom_target(
            gen_docs
            COMMAND ${PROJECT_SOURCE_DIR}/scripts/run_doxygen.sh ${DOXYGEN_EXECUTABLE} ${DOXYFILE} ${PROJECT_BINARY_DIR}
            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
            COMMENT "Generate API documentation with Doxygen."
            USES_TERMINAL)

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

add_subdirectory(common)

# initialize KEM|SIG_OBJS for --warn-uninitialized
set(KEM_OBJS "")
set(SIG_OBJS "")
set(SIG_STFL_OBJS "")

if(${OQS_ENABLE_KEM_BIKE})
    add_subdirectory(kem/bike)
    set(KEM_OBJS ${KEM_OBJS} ${BIKE_OBJS})
endif()
if(${OQS_ENABLE_KEM_FRODOKEM})
    add_subdirectory(kem/frodokem)
    set(KEM_OBJS ${KEM_OBJS} ${FRODOKEM_OBJS})
endif()
if(OQS_ENABLE_KEM_NTRUPRIME)
    add_subdirectory(kem/ntruprime)
    set(KEM_OBJS ${KEM_OBJS} ${NTRUPRIME_OBJS})
endif()
##### OQS_COPY_FROM_UPSTREAM_FRAGMENT_ADD_ALG_OBJECTS_START
if(OQS_ENABLE_KEM_CLASSIC_MCELIECE)
    add_subdirectory(kem/classic_mceliece)
    set(KEM_OBJS ${KEM_OBJS} ${CLASSIC_MCELIECE_OBJS})
endif()
if(OQS_ENABLE_KEM_HQC)
    add_subdirectory(kem/hqc)
    set(KEM_OBJS ${KEM_OBJS} ${HQC_OBJS})
endif()
if(OQS_ENABLE_KEM_KYBER)
    add_subdirectory(kem/kyber)
    set(KEM_OBJS ${KEM_OBJS} ${KYBER_OBJS})
endif()
if(OQS_ENABLE_KEM_ML_KEM)
    add_subdirectory(kem/ml_kem)
    set(KEM_OBJS ${KEM_OBJS} ${ML_KEM_OBJS})
endif()
if(OQS_ENABLE_SIG_DILITHIUM)
    add_subdirectory(sig/dilithium)
    set(SIG_OBJS ${SIG_OBJS} ${DILITHIUM_OBJS})
endif()
if(OQS_ENABLE_SIG_ML_DSA)
    add_subdirectory(sig/ml_dsa)
    set(SIG_OBJS ${SIG_OBJS} ${ML_DSA_OBJS})
endif()
if(OQS_ENABLE_SIG_FALCON)
    add_subdirectory(sig/falcon)
    set(SIG_OBJS ${SIG_OBJS} ${FALCON_OBJS})
endif()
if(OQS_ENABLE_SIG_SPHINCS)
    add_subdirectory(sig/sphincs)
    set(SIG_OBJS ${SIG_OBJS} ${SPHINCS_OBJS})
endif()
if(OQS_ENABLE_SIG_MAYO)
    add_subdirectory(sig/mayo)
    set(SIG_OBJS ${SIG_OBJS} ${MAYO_OBJS})
endif()
if(OQS_ENABLE_SIG_CROSS)
    add_subdirectory(sig/cross)
    set(SIG_OBJS ${SIG_OBJS} ${CROSS_OBJS})
endif()
if(OQS_ENABLE_SIG_UOV)
    add_subdirectory(sig/uov)
    set(SIG_OBJS ${SIG_OBJS} ${UOV_OBJS})
endif()
##### OQS_COPY_FROM_UPSTREAM_FRAGMENT_ADD_ALG_OBJECTS_END

if(OQS_ENABLE_SIG_STFL_XMSS)
    add_subdirectory(sig_stfl/xmss)
    set(SIG_STFL_OBJS ${SIG_STFL_OBJS} ${XMSS_OBJS})
endif()

if(OQS_ENABLE_SIG_STFL_LMS)
    add_subdirectory(sig_stfl/lms)
    set(SIG_STFL_OBJS ${SIG_STFL_OBJS} ${LMS_OBJS})
endif()

add_library(oqs kem/kem.c
                ${KEM_OBJS}
                sig/sig.c
                ${SIG_OBJS}
                sig_stfl/sig_stfl.c
                ${SIG_STFL_OBJS}
                ${COMMON_OBJS})

# Internal library to be used only by test programs
add_library(oqs-internal STATIC ${INTERNAL_OBJS})

if(DEFINED SANITIZER_LD_FLAGS)
    target_link_libraries(oqs PUBLIC ${SANITIZER_LD_FLAGS})
    target_link_libraries(oqs-internal PUBLIC ${SANITIZER_LD_FLAGS})
endif()
if(${OQS_USE_OPENSSL})
  if(${OQS_DLOPEN_OPENSSL})
    target_link_libraries(oqs PRIVATE ${CMAKE_DL_LIBS})
    target_link_libraries(oqs-internal PRIVATE ${CMAKE_DL_LIBS})
  else()
    target_link_libraries(oqs PRIVATE ${OPENSSL_CRYPTO_LIBRARY})
    target_link_libraries(oqs-internal PRIVATE ${OPENSSL_CRYPTO_LIBRARY})
  endif()
endif()
if(${OQS_USE_CUPQC})
    set_property(TARGET oqs PROPERTY CUDA_RESOLVE_DEVICE_SYMBOLS ON)
    target_link_libraries(oqs PRIVATE cupqc)
    target_link_options(oqs PRIVATE $<DEVICE_LINK: -dlto>)
endif()

target_include_directories(oqs
                           PUBLIC
                           "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
                           "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
)

target_include_directories(oqs-internal
                           PUBLIC
                           "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
                           "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
)

if(MINGW)
    target_link_options(oqs-internal PRIVATE -Wl,--export-all-symbols)
endif()

set_target_properties(oqs
    PROPERTIES
    ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib"
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib"
    VERSION ${OQS_VERSION_TEXT}
    SOVERSION 7
    # For Windows DLLs
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")

set_target_properties(oqs-internal
    PROPERTIES
    C_VISIBILITY_PRESET default
    ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib"
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib"
    # For Windows DLLs
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")

configure_package_config_file(${CMAKE_CURRENT_SOURCE_DIR}/Config.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/liboqsConfig.cmake"
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/liboqs
)

# generate the version file for the config file
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/liboqsConfigVersion.cmake"
  VERSION "${OQS_VERSION_TEXT}"
  COMPATIBILITY AnyNewerVersion
)

if(OQS_USE_OPENSSL)
    set(_oqs_pkgconfig_requires_private openssl)
endif()

# generate pkg-config file
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/liboqs.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/liboqs.pc
  @ONLY
)

install(FILES
          "${CMAKE_CURRENT_BINARY_DIR}/liboqsConfig.cmake"
          "${CMAKE_CURRENT_BINARY_DIR}/liboqsConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/liboqs"
)

install(FILES
          "${CMAKE_CURRENT_BINARY_DIR}/liboqs.pc"
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

install(TARGETS oqs
        EXPORT liboqsTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/oqs
)

install(EXPORT liboqsTargets
        FILE liboqsTargets.cmake
        NAMESPACE OQS::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/liboqs
)

install(FILES ${PUBLIC_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/oqs)

export(EXPORT liboqsTargets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/liboqsTargets.cmake"
       NAMESPACE OQS::
)

=== tests/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

option(OQS_ENABLE_TEST_CONSTANT_TIME "Build test suite with support for Valgrind-based detection of non-constant time behaviour." OFF)

if(CMAKE_C_COMPILER_ID STREQUAL "GNU" OR
   CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wbad-function-cast)
endif()
if(CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wcast-qual)
    add_compile_options(-Wnarrowing)
    add_compile_options(-Wconversion)
endif()
if (MINGW OR MSYS OR CYGWIN)
    add_definitions(-D__USE_MINGW_ANSI_STDIO=1)
    add_compile_options(-Wno-unknown-pragmas)
    add_compile_options(-Wno-unused-parameter)
endif()
if(WIN32 AND NOT (MINGW OR MSYS OR CYGWIN))
    # ignore warning for test apps
    add_compile_options(/wd4996 /wd4244)
endif()

if(OQS_USE_OPENSSL)
    include_directories(${OPENSSL_INCLUDE_DIR})
endif()

if(NOT WIN32)
    set(LIBM m)
endif()

# List oqs-internal after oqs so that oqs has linking precedence.
if(${OQS_USE_OPENSSL})
    find_package(OpenSSL 1.1.1 REQUIRED)
    set(TEST_DEPS oqs oqs-internal ${LIBM} OpenSSL::Crypto)
else()
    set(TEST_DEPS oqs oqs-internal ${LIBM})
endif()

if(OQS_USE_PTHREADS)
    set(TEST_DEPS ${TEST_DEPS} Threads::Threads)
endif()

if(NOT WIN32)
    execute_process(COMMAND ${PROJECT_SOURCE_DIR}/scripts/git_commit.sh OUTPUT_VARIABLE GIT_COMMIT)
    add_definitions(-DOQS_COMPILE_GIT_COMMIT="${GIT_COMMIT}")

    add_executable(test_aes test_aes.c)
    target_link_libraries(test_aes PRIVATE ${TEST_DEPS})

    add_executable(test_hash test_hash.c)
    target_link_libraries(test_hash PRIVATE ${TEST_DEPS})

    add_executable(test_sha3 test_sha3.c)
    target_link_libraries(test_sha3 PRIVATE ${TEST_DEPS})

    add_executable(speed_common speed_common.c)
    target_link_libraries(speed_common PRIVATE ${TEST_DEPS})

    set(UNIX_TESTS test_aes test_hash test_sha3 speed_common)

    set(PYTHON3_EXEC python3)
else()
    set(PYTHON3_EXEC python)
endif()

# KEM API tests
add_executable(example_kem example_kem.c)
target_link_libraries(example_kem PRIVATE ${TEST_DEPS})

add_executable(kat_kem kat_kem.c test_helpers.c)
target_link_libraries(kat_kem PRIVATE ${TEST_DEPS})
if(CMAKE_SYSTEM_NAME STREQUAL "Windows" AND BUILD_SHARED_LIBS)
    # workaround for Windows .dll
    if(MINGW OR MSYS OR CYGWIN OR CMAKE_CROSSCOMPILING)
        target_link_options(kat_kem PRIVATE -Wl,--allow-multiple-definition)
    else()
        target_link_options(kat_kem PRIVATE "/FORCE:MULTIPLE")
    endif()
endif()

add_executable(test_kem test_kem.c test_helpers.c)
target_link_libraries(test_kem PRIVATE ${TEST_DEPS})

if(CMAKE_SYSTEM_NAME STREQUAL "Windows" AND BUILD_SHARED_LIBS)
    # workaround for Windows .dll
    if(MINGW OR MSYS OR CYGWIN OR CMAKE_CROSSCOMPILING)
        target_link_options(test_kem PRIVATE -Wl,--allow-multiple-definition)
    else()
        target_link_options(test_kem PRIVATE "/FORCE:MULTIPLE")
    endif()
endif()

add_executable(test_kem_mem test_kem_mem.c test_helpers.c)
target_link_libraries(test_kem_mem PRIVATE ${TEST_DEPS})
if(CMAKE_SYSTEM_NAME STREQUAL "Windows" AND BUILD_SHARED_LIBS)
    # workaround for Windows .dll
    if(MINGW OR MSYS OR CYGWIN OR CMAKE_CROSSCOMPILING)
        target_link_options(test_kem_mem PRIVATE -Wl,--allow-multiple-definition)
    else()
        target_link_options(test_kem_mem PRIVATE "/FORCE:MULTIPLE")
    endif()
endif()

add_executable(speed_kem speed_kem.c)
target_link_libraries(speed_kem PRIVATE ${TEST_DEPS})

set(KEM_TESTS example_kem kat_kem test_kem test_kem_mem speed_kem vectors_kem)

# SIG API tests
add_executable(example_sig example_sig.c)
target_link_libraries(example_sig PRIVATE ${TEST_DEPS})

if(OQS_BUILD_FUZZ_TESTS AND '${CMAKE_C_COMPILER_ID}' STREQUAL 'Clang')
    add_executable(fuzz_test_sig fuzz_test_sig.c)
    target_link_libraries(fuzz_test_sig PRIVATE ${TEST_DEPS})
    set_target_properties(fuzz_test_sig PROPERTIES
        COMPILE_FLAGS "${FUZZING_COMPILE_FLAGS}"
        LINK_FLAGS "${FUZZING_LINK_FLAGS}"
    )
endif()

# Stateful SIG API tests
add_executable(example_sig_stfl example_sig_stfl.c)
target_link_libraries(example_sig_stfl PRIVATE ${TEST_DEPS})

add_executable(kat_sig kat_sig.c test_helpers.c)
target_link_libraries(kat_sig PRIVATE ${TEST_DEPS})
if(CMAKE_SYSTEM_NAME STREQUAL "Windows" AND BUILD_SHARED_LIBS)
    # workaround for Windows .dll
    if(MINGW OR MSYS OR CYGWIN OR CMAKE_CROSSCOMPILING)
        target_link_options(kat_sig PRIVATE -Wl,--allow-multiple-definition)
    else()
        target_link_options(kat_sig PRIVATE "/FORCE:MULTIPLE")
    endif()
endif()

add_executable(kat_sig_stfl kat_sig_stfl.c test_helpers.c)
target_link_libraries(kat_sig_stfl PRIVATE ${TEST_DEPS})
if(CMAKE_SYSTEM_NAME STREQUAL "Windows" AND BUILD_SHARED_LIBS)
    # workaround for Windows .dll
    if(CMAKE_CROSSCOMPILING)
        target_link_options(kat_sig_stfl PRIVATE -Wl,--allow-multiple-definition)
    else()
        target_link_options(kat_sig_stfl PRIVATE "/FORCE:MULTIPLE")
    endif()
endif()

add_executable(test_sig test_sig.c test_helpers.c)
target_link_libraries(test_sig PRIVATE ${TEST_DEPS})
if(CMAKE_SYSTEM_NAME STREQUAL "Windows" AND BUILD_SHARED_LIBS)
    # workaround for Windows .dll
    if(CMAKE_CROSSCOMPILING)
        target_link_options(test_sig PRIVATE -Wl,--allow-multiple-definition)
    else()
        target_link_options(test_sig PRIVATE "/FORCE:MULTIPLE")
    endif()
endif()

add_executable(test_sig_mem test_sig_mem.c)
target_link_libraries(test_sig_mem PRIVATE ${TEST_DEPS})

add_executable(speed_sig speed_sig.c)
target_link_libraries(speed_sig PRIVATE ${TEST_DEPS})


set(SIG_TESTS example_sig kat_sig test_sig test_sig_mem speed_sig vectors_sig)

# SIG_STFL API tests
add_executable(test_sig_stfl test_sig_stfl.c test_helpers.c)
if((CMAKE_C_COMPILER_ID MATCHES "Clang") OR (CMAKE_C_COMPILER_ID STREQUAL "GNU"))
    target_link_libraries(test_sig_stfl PRIVATE ${TEST_DEPS} Threads::Threads)
else ()
    target_link_libraries(test_sig_stfl PRIVATE ${TEST_DEPS})
endif()
if(CMAKE_SYSTEM_NAME STREQUAL "Windows" AND BUILD_SHARED_LIBS)
    # workaround for Windows .dll
    if(CMAKE_CROSSCOMPILING)
        target_link_options(test_sig_stfl PRIVATE -Wl,--allow-multiple-definition)
    else()
        target_link_options(test_sig_stfl PRIVATE "/FORCE:MULTIPLE")
    endif()
endif()

add_executable(speed_sig_stfl speed_sig_stfl.c)
target_link_libraries(speed_sig_stfl PRIVATE ${TEST_DEPS})

set(SIG_STFL_TESTS kat_sig_stfl test_sig_stfl speed_sig_stfl)

add_executable(dump_alg_info dump_alg_info.c)
target_link_libraries(dump_alg_info PRIVATE ${TEST_DEPS})

# Intermediate values vector tests
add_executable(vectors_sig vectors_sig.c)
target_link_libraries(vectors_sig PRIVATE ${TEST_DEPS})

add_executable(vectors_kem vectors_kem.c)
target_link_libraries(vectors_kem PRIVATE ${TEST_DEPS})

if(CMAKE_SYSTEM_NAME STREQUAL "Windows" AND BUILD_SHARED_LIBS)
    # workaround for Windows .dll
    if(MINGW OR MSYS OR CYGWIN OR CMAKE_CROSSCOMPILING)
        target_link_options(vectors_kem PRIVATE -Wl,--allow-multiple-definition)
    else()
        target_link_options(vectors_kem PRIVATE "/FORCE:MULTIPLE")
    endif()
endif()

# Enable Valgrind-based timing side-channel analysis for test_kem and test_sig
if(OQS_ENABLE_TEST_CONSTANT_TIME AND NOT OQS_DEBUG_BUILD)
    message(WARNING "OQS_ENABLE_TEST_CONSTANT_TIME is incompatible with CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}.")
    set(OQS_ENABLE_TEST_CONSTANT_TIME OFF)
endif()

# Record compile options -- from target speed_kem - don't set any options only for speed_kem!
get_property(OQS_COMPILE_OPTIONS TARGET speed_kem PROPERTY COMPILE_OPTIONS)
add_definitions(-DOQS_COMPILE_OPTIONS="[${OQS_COMPILE_OPTIONS}]")

if (CMAKE_GENERATOR MATCHES "Visual Studio")
    # With Visual studio the output of tests go into a folder with the configuration option. Force it to the same folder as if
    # generating with Ninja
    set_target_properties(
        dump_alg_info ${KEM_TESTS} ${SIG_TESTS}
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY_DEBUG          "${CMAKE_BINARY_DIR}/tests"
        RUNTIME_OUTPUT_DIRECTORY_RELEASE        "${CMAKE_BINARY_DIR}/tests"
        RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO "${CMAKE_BINARY_DIR}/tests"
        RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL     "${CMAKE_BINARY_DIR}/tests")
endif()

# TODO: Get CMake to find python.
# and set PATH variable in Windows
# for DLL builds.
add_custom_target(
    run_tests
    # skip long KAT tests
    COMMAND ${CMAKE_COMMAND} -E env OQS_BUILD_DIR=${CMAKE_BINARY_DIR} ${PYTHON3_EXEC} -m pytest --verbose --numprocesses=auto --ignore=scripts/copy_from_upstream/repos --ignore=tests/test_kat_all.py
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    DEPENDS oqs dump_alg_info ${KEM_TESTS} ${SIG_TESTS} ${SIG_STFL_TESTS} ${UNIX_TESTS}
    USES_TERMINAL)

=== zephyr/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# Only add liboqs Zephyr module if enabled in Kconfig
if(CONFIG_LIBOQS)

        # Workarounds for Zephyr
        if(CMAKE_SYSTEM_PROCESSOR STREQUAL "arm")
                # Workaround as the generic name "arm" is not a supported architecture in liboqs.
                # In Zephyr, however, it is exclusively used for 32-bit ARM architectures.
                set(CMAKE_SYSTEM_PROCESSOR "armv7")
        elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "riscv")
                # Zephyr doesn't distinguish between 32-bit and 64-bit RISC-V architectures.
                if(CONFIG_64BIT)
                        set(CMAKE_SYSTEM_PROCESSOR "riscv64")
                else()
                        set(CMAKE_SYSTEM_PROCESSOR "riscv32")
                endif()
        elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "posix")
                # Workaround to enable the native Zephyr builds on the Linux host system.
                if(BOARD MATCHES "native_posix|native_sim")
                        set(CMAKE_SYSTEM_PROCESSOR ${CMAKE_HOST_SYSTEM_PROCESSOR})
                else()
                        message(FATAL_ERROR "Unsupported board ${BOARD} with posix architecture")
                endif()
        elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86")
                # Zephyr doesn't distinguish between 32-bit and 64-bit x86 architectures.
                if(CONFIG_64BIT)
                        set(CMAKE_SYSTEM_PROCESSOR "x86_64")
                endif()
        endif()

        # We have to set CMAKE_SIZEOF_VOID_P manually as CMake can't detect it properly in Zephyr
        if(CONFIG_64BIT)
                set(CMAKE_SIZEOF_VOID_P 8)
        else()
                set(CMAKE_SIZEOF_VOID_P 4)
        endif()

        # Configuration for liboqs
        set(OQS_DIST_BUILD  OFF)
        set(OQS_BUILD_ONLY_LIB ON)
        set(OQS_USE_OPENSSL OFF)
        set(OQS_EMBEDDED_BUILD ON)

        set(CMAKE_CROSSCOMPILING ON)

        # Disable features by hand, as CMake won't find them properly with Zephyr
        set(CMAKE_HAVE_GETENTROPY OFF)
        set(CMAKE_HAVE_ALIGNED_ALLOC OFF)
        set(CMAKE_HAVE_POSIX_MEMALIGN OFF)
        set(CMAKE_HAVE_MEMALIGN OFF)
        set(CMAKE_HAVE_EXPLICIT_BZERO OFF)
        set(CMAKE_HAVE_MEMSET_S OFF)
        set(CC_SUPPORTS_WA_NOEXECSTACK OFF)
        set(LD_SUPPORTS_WL_Z_NOEXECSTACK OFF)

        # Algorithm selection (based on Kconfig)
        if(CONFIG_LIBOQS_ENABLE_KEM_BIKE)
                set(OQS_ENABLE_KEM_BIKE ON)
        else()
                set(OQS_ENABLE_KEM_BIKE OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_KEM_FRODOKEM)
                set(OQS_ENABLE_KEM_FRODOKEM ON)
        else()
                set(OQS_ENABLE_KEM_FRODOKEM OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_KEM_NTRUPRIME)
                set(OQS_ENABLE_KEM_NTRUPRIME ON)
        else()
                set(OQS_ENABLE_KEM_NTRUPRIME OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_KEM_CLASSIC_MCELIECE)
                set(OQS_ENABLE_KEM_CLASSIC_MCELIECE ON)
        else()
                set(OQS_ENABLE_KEM_CLASSIC_MCELIECE OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_KEM_HQC)
                set(OQS_ENABLE_KEM_HQC ON)
        else()
                set(OQS_ENABLE_KEM_HQC OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_KEM_KYBER)
                set(OQS_ENABLE_KEM_KYBER ON)
        else()
                set(OQS_ENABLE_KEM_KYBER OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_KEM_ML_KEM)
                set(OQS_ENABLE_KEM_ML_KEM ON)
        else()
                set(OQS_ENABLE_KEM_ML_KEM OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_DILITHIUM)
                set(OQS_ENABLE_SIG_DILITHIUM ON)
        else()
                set(OQS_ENABLE_SIG_DILITHIUM OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_ML_DSA)
                set(OQS_ENABLE_SIG_ML_DSA ON)
        else()
                set(OQS_ENABLE_SIG_ML_DSA OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_FALCON)
                set(OQS_ENABLE_SIG_FALCON ON)
        else()
                set(OQS_ENABLE_SIG_FALCON OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_SPHINCS)
                set(OQS_ENABLE_SIG_SPHINCS ON)
        else()
                set(OQS_ENABLE_SIG_SPHINCS OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_MAYO)
                set(OQS_ENABLE_SIG_MAYO ON)
                set(OQS_ENABLE_SIG_mayo_5 OFF)
        else()  
                set(OQS_ENABLE_SIG_MAYO OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_UOV)
                set(OQS_ENABLE_SIG_UOV ON)
        else()  
                set(OQS_ENABLE_SIG_UOV OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_CROSS)
                set(OQS_ENABLE_SIG_CROSS ON)
                # Disable CROSS variants with large stack usage
                set(OQS_ENABLE_SIG_cross_rsdp_128_small OFF)
                set(OQS_ENABLE_SIG_cross_rsdp_192_small OFF)
                set(OQS_ENABLE_SIG_cross_rsdp_256_balanced OFF)
                set(OQS_ENABLE_SIG_cross_rsdp_256_small OFF)
                set(OQS_ENABLE_SIG_cross_rsdpg_192_small OFF)
                set(OQS_ENABLE_SIG_cross_rsdpg_256_small OFF)
        else()  
                set(OQS_ENABLE_SIG_CROSS OFF)
        endif()

        # Add the actual liboqs targets
        add_subdirectory(.. build)

        # Add target specific options to all liboqs targets
        zephyr_get_targets(.. "STATIC_LIBRARY;OBJECT_LIBRARY" ALL_TARGETS)
        foreach(target ${ALL_TARGETS})
                # Zephyr include directories
                target_include_directories(${target} PRIVATE
                        $<TARGET_PROPERTY:zephyr_interface,INTERFACE_INCLUDE_DIRECTORIES>
                )

                # Zephyr system include directories
                target_include_directories(${target} SYSTEM PRIVATE
                        $<TARGET_PROPERTY:zephyr_interface,INTERFACE_SYSTEM_INCLUDE_DIRECTORIES>
                )

                # Definitions
                target_compile_definitions(${target} PRIVATE
                        $<TARGET_PROPERTY:zephyr_interface,INTERFACE_COMPILE_DEFINITIONS>
                )

                # Compile options (includes compiler flags)
                target_compile_options(${target} PRIVATE
                        $<TARGET_PROPERTY:zephyr_interface,INTERFACE_COMPILE_OPTIONS>
                        $<TARGET_PROPERTY:compiler,no_builtin>
                )

                # liboqs depends on unistd.h, which ultimately needs the generated syscall_list.h file,
                # which is generated as part of ${SYSCALL_LIST_H_TARGET} target. Therefore, we have to
                # make sure that target is built before liboqs.
                add_dependencies(${target} ${SYSCALL_LIST_H_TARGET})

                # We don't want position independent code
                set_target_properties(${target} PROPERTIES POSITION_INDEPENDENT_CODE OFF)
        endforeach()

        # Link the liboqs library
        zephyr_link_libraries(oqs)

        # Include the liboqs headers
        zephyr_include_directories(${CMAKE_CURRENT_BINARY_DIR}/build/include)

        # Undo the Zephyr workarounds from above to not interfere with other modules
        if(CMAKE_SYSTEM_PROCESSOR STREQUAL "armv7")
                set(CMAKE_SYSTEM_PROCESSOR "arm")
        elseif(CMAKE_SYSTEM_PROCESSOR EQUAL CMAKE_HOST_SYSTEM_PROCESSOR)
                set(CMAKE_SYSTEM_PROCESSOR "posix")
        elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "riscv")
                set(CMAKE_SYSTEM_PROCESSOR "riscv")
        elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
                set(CMAKE_SYSTEM_PROCESSOR "x86")
        endif()
endif()

=== src/common/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

include(CheckSymbolExists)

# initialize to avoid --warn-uninitialized report
set(_COMMON_OBJS "")
set(_INTERNAL_OBJS "")

if(CMAKE_C_COMPILER_ID STREQUAL "GNU" OR
   CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wbad-function-cast)
endif()
if(CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wcast-qual)
    add_compile_options(-Wnarrowing)
    add_compile_options(-Wconversion)
endif()

set(OSSL_HELPERS "")

if(${OQS_USE_AES_OPENSSL})
    set(AES_IMPL aes/aes_ossl.c)
    set(OSSL_HELPERS ossl_helpers.c)
else()
   set(AES_IMPL aes/aes_impl.c aes/aes_c.c)
   if (OQS_DIST_X86_64_BUILD OR OQS_USE_AES_INSTRUCTIONS)
      set(AES_IMPL ${AES_IMPL} aes/aes128_ni.c)
      set(AES_IMPL ${AES_IMPL} aes/aes256_ni.c)
      set_source_files_properties(aes/aes128_ni.c PROPERTIES COMPILE_FLAGS "-maes -mssse3")
      set_source_files_properties(aes/aes256_ni.c PROPERTIES COMPILE_FLAGS "-maes -mssse3")
   elseif (OQS_DIST_ARM64_V8_BUILD)
      set(AES_IMPL ${AES_IMPL} aes/aes128_armv8.c)
      set(AES_IMPL ${AES_IMPL} aes/aes256_armv8.c)
      set_source_files_properties(aes/aes128_armv8.c PROPERTIES COMPILE_FLAGS -mcpu=cortex-a53+crypto)
      set_source_files_properties(aes/aes256_armv8.c PROPERTIES COMPILE_FLAGS -mcpu=cortex-a53+crypto)
   elseif (OQS_USE_ARM_AES_INSTRUCTIONS)
      set(AES_IMPL ${AES_IMPL} aes/aes128_armv8.c)
      set(AES_IMPL ${AES_IMPL} aes/aes256_armv8.c)
       if ((CMAKE_SYSTEM_NAME MATCHES "Darwin") AND (${CMAKE_C_COMPILER_ID} STREQUAL "GNU"))
         set_source_files_properties(aes/aes128_armv8.c PROPERTIES COMPILE_FLAGS -march=armv8-a+crypto)
         set_source_files_properties(aes/aes256_armv8.c PROPERTIES COMPILE_FLAGS -march=armv8-a+crypto)
       endif()
   endif()
endif()

if(${OQS_USE_SHA2_OPENSSL})
    set(SHA2_IMPL sha2/sha2_ossl.c)
    set(OSSL_HELPERS ossl_helpers.c)
else()
    set(SHA2_IMPL sha2/sha2_impl.c sha2/sha2_c.c)
    if (OQS_DIST_ARM64_V8_BUILD)
       set(SHA2_IMPL ${SHA2_IMPL} sha2/sha2_armv8.c)
       set_source_files_properties(sha2/sha2_armv8.c PROPERTIES COMPILE_FLAGS -mcpu=cortex-a53+crypto)
    elseif (OQS_USE_ARM_SHA2_INSTRUCTIONS)
       # Assume we are compiling native
       set(SHA2_IMPL ${SHA2_IMPL} sha2/sha2_armv8.c)
       if ((CMAKE_SYSTEM_NAME MATCHES "Darwin") AND (${CMAKE_C_COMPILER_ID} STREQUAL "GNU"))
         set_source_files_properties(sha2/sha2_armv8.c PROPERTIES COMPILE_FLAGS -march=armv8-a+crypto)
       endif()
    endif()
endif()

if(${OQS_USE_SHA3_OPENSSL})
  if (${OQS_ENABLE_SHA3_xkcp_low})
    add_subdirectory(sha3/xkcp_low)
  endif()
    set(SHA3_IMPL sha3/ossl_sha3.c sha3/ossl_sha3x4.c)
    set(OSSL_HELPERS ossl_helpers.c)
else() # using XKCP
    add_subdirectory(sha3/xkcp_low)
    set(SHA3_IMPL sha3/xkcp_sha3.c sha3/xkcp_sha3x4.c)
endif()

if ((OQS_LIBJADE_BUILD STREQUAL "ON"))
    set(LIBJADE_RANDOMBYTES libjade_shims/libjade_randombytes.c)
else()
    set(LIBJADE_RANDOMBYTES "")
endif()

add_library(common OBJECT ${AES_IMPL} aes/aes.c
                          ${SHA2_IMPL} sha2/sha2.c
                          ${SHA3_IMPL} sha3/sha3.c sha3/sha3x4.c
                          ${OSSL_HELPERS}
                          common.c
                          pqclean_shims/fips202.c
                          pqclean_shims/fips202x4.c
                          ${LIBJADE_RANDOMBYTES}
                          rand/rand.c)

# Implementations of the internal API to be exposed to test programs
add_library(internal OBJECT ${AES_IMPL} aes/aes.c
                            ${SHA2_IMPL} sha2/sha2.c
                            ${SHA3_IMPL} sha3/sha3.c sha3/sha3x4.c
                            ${OSSL_HELPERS}
                            common.c
                            rand/rand_nist.c)
set_property(TARGET internal PROPERTY C_VISIBILITY_PRESET default)

if(${OQS_USE_OPENSSL})
    target_include_directories(common PRIVATE ${OPENSSL_INCLUDE_DIR})
    target_include_directories(internal PRIVATE ${OPENSSL_INCLUDE_DIR})
else()
    check_symbol_exists(getentropy "unistd.h" CMAKE_UNISTD_HAVE_GETENTROPY)
    check_symbol_exists(getentropy "sys/random.h" CMAKE_SYS_RANDOM_HAVE_GETENTROPY)
    if("${CMAKE_UNISTD_HAVE_GETENTROPY}" OR "${CMAKE_SYS_RANDOM_HAVE_GETENTROPY}")
        target_compile_definitions(common PRIVATE OQS_HAVE_GETENTROPY)
        target_compile_definitions(internal PRIVATE OQS_HAVE_GETENTROPY)
    endif()
endif()
if(OQS_USE_PTHREADS)
    target_link_libraries(common PRIVATE Threads::Threads)
    target_link_libraries(internal PRIVATE Threads::Threads)
endif()

# check available functions to perform aligned mallocs
check_symbol_exists(aligned_alloc stdlib.h CMAKE_HAVE_ALIGNED_ALLOC)
check_symbol_exists(posix_memalign stdlib.h CMAKE_HAVE_POSIX_MEMALIGN)
check_symbol_exists(memalign malloc.h CMAKE_HAVE_MEMALIGN)

if(CMAKE_HAVE_ALIGNED_ALLOC)
    target_compile_definitions(common PRIVATE OQS_HAVE_ALIGNED_ALLOC)
    target_compile_definitions(internal PRIVATE OQS_HAVE_ALIGNED_ALLOC)
endif()

if(CMAKE_HAVE_POSIX_MEMALIGN)
    target_compile_definitions(common PRIVATE OQS_HAVE_POSIX_MEMALIGN)
    target_compile_definitions(internal PRIVATE OQS_HAVE_POSIX_MEMALIGN)
endif()

if(CMAKE_HAVE_MEMALIGN)
    target_compile_definitions(common PRIVATE OQS_HAVE_MEMALIGN)
    target_compile_definitions(internal PRIVATE OQS_HAVE_MEMALIGN)
endif()

# check if explicit_bzero, or explicit_memset exists or memset_s
check_symbol_exists(explicit_bzero string.h CMAKE_HAVE_EXPLICIT_BZERO)
check_symbol_exists(explicit_memset string.h CMAKE_HAVE_EXPLICIT_MEMSET)
check_symbol_exists(memset_s string.h CMAKE_HAVE_MEMSET_S)

if(CMAKE_HAVE_EXPLICIT_BZERO)
    target_compile_definitions(common PRIVATE OQS_HAVE_EXPLICIT_BZERO)
    target_compile_definitions(internal PRIVATE OQS_HAVE_EXPLICIT_BZERO)
endif()

if(CMAKE_HAVE_EXPLICIT_MEMSET)
    target_compile_definitions(common PRIVATE OQS_HAVE_EXPLICIT_MEMSET)
    target_compile_definitions(internal PRIVATE OQS_HAVE_EXPLICIT_MEMSET)
endif()

if(CMAKE_HAVE_MEMSET_S)
    target_compile_definitions(common PRIVATE OQS_HAVE_MEMSET_S)
    target_compile_definitions(internal PRIVATE OQS_HAVE_MEMSET_S)
endif()

if(${OQS_ENABLE_SHA3_xkcp_low}) # using XKCP
    set(_COMMON_OBJS ${_COMMON_OBJS} ${XKCP_LOW_OBJS})
    set(_INTERNAL_OBJS ${_INTERNAL_OBJS} ${XKCP_LOW_OBJS})
endif()

set(_COMMON_OBJS ${_COMMON_OBJS} $<TARGET_OBJECTS:common>)
set(COMMON_OBJS ${_COMMON_OBJS} PARENT_SCOPE)
set(_INTERNAL_OBJS ${_INTERNAL_OBJS} $<TARGET_OBJECTS:internal>)
set(INTERNAL_OBJS ${_INTERNAL_OBJS} PARENT_SCOPE)

=== src/kem/ml_kem/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# This file was generated by
# scripts/copy_from_upstream/copy_from_upstream.py

set(_ML_KEM_OBJS "")

if(OQS_ENABLE_KEM_ml_kem_512)
    add_library(ml_kem_512_ref OBJECT kem_ml_kem_512.c mlkem-native_ml-kem-512_ref/mlkem/compress.c mlkem-native_ml-kem-512_ref/mlkem/debug.c mlkem-native_ml-kem-512_ref/mlkem/indcpa.c mlkem-native_ml-kem-512_ref/mlkem/kem.c mlkem-native_ml-kem-512_ref/mlkem/poly.c mlkem-native_ml-kem-512_ref/mlkem/poly_k.c mlkem-native_ml-kem-512_ref/mlkem/sampling.c mlkem-native_ml-kem-512_ref/mlkem/verify.c)
    target_compile_options(ml_kem_512_ref PUBLIC -DMLKEM_K=2 -DMLK_CONFIG_FILE="../integration/liboqs/config_c.h")
    target_include_directories(ml_kem_512_ref PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-512_ref)
    target_include_directories(ml_kem_512_ref PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_512_ref PUBLIC -DMLKEM_K=2 -DMLK_CONFIG_FILE="../integration/liboqs/config_c.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_512_ref>)
endif()

if(OQS_ENABLE_KEM_ml_kem_512_x86_64)
    add_library(ml_kem_512_x86_64 OBJECT mlkem-native_ml-kem-512_x86_64/mlkem/compress.c mlkem-native_ml-kem-512_x86_64/mlkem/debug.c mlkem-native_ml-kem-512_x86_64/mlkem/indcpa.c mlkem-native_ml-kem-512_x86_64/mlkem/kem.c mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/basemul.c mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/basemul.S mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/compress_avx2.c mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/consts.c mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/intt.S mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/ntt.S mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/nttfrombytes.S mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/nttpack.S mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/ntttobytes.S mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/nttunpack.S mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/reduce.S mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/rej_uniform_avx2.c mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/rej_uniform_table.c mlkem-native_ml-kem-512_x86_64/mlkem/native/x86_64/src/tomont.S mlkem-native_ml-kem-512_x86_64/mlkem/poly.c mlkem-native_ml-kem-512_x86_64/mlkem/poly_k.c mlkem-native_ml-kem-512_x86_64/mlkem/sampling.c mlkem-native_ml-kem-512_x86_64/mlkem/verify.c)
    target_include_directories(ml_kem_512_x86_64 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-512_x86_64)
    target_include_directories(ml_kem_512_x86_64 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_512_x86_64 PRIVATE  -mavx2  -mbmi2  -mpopcnt )
    target_compile_options(ml_kem_512_x86_64 PUBLIC -DMLKEM_K=2 -DMLK_CONFIG_FILE="../integration/liboqs/config_x86_64.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_512_x86_64>)
endif()

if(OQS_ENABLE_KEM_ml_kem_512_aarch64)
    add_library(ml_kem_512_aarch64 OBJECT mlkem-native_ml-kem-512_aarch64/mlkem/compress.c mlkem-native_ml-kem-512_aarch64/mlkem/debug.c mlkem-native_ml-kem-512_aarch64/mlkem/indcpa.c mlkem-native_ml-kem-512_aarch64/mlkem/kem.c mlkem-native_ml-kem-512_aarch64/mlkem/native/aarch64/src/aarch64_zetas.c mlkem-native_ml-kem-512_aarch64/mlkem/native/aarch64/src/intt.S mlkem-native_ml-kem-512_aarch64/mlkem/native/aarch64/src/ntt.S mlkem-native_ml-kem-512_aarch64/mlkem/native/aarch64/src/poly_mulcache_compute_asm.S mlkem-native_ml-kem-512_aarch64/mlkem/native/aarch64/src/poly_reduce_asm.S mlkem-native_ml-kem-512_aarch64/mlkem/native/aarch64/src/poly_tobytes_asm.S mlkem-native_ml-kem-512_aarch64/mlkem/native/aarch64/src/poly_tomont_asm.S mlkem-native_ml-kem-512_aarch64/mlkem/native/aarch64/src/polyvec_basemul_acc_montgomery_cached_asm_k2.S mlkem-native_ml-kem-512_aarch64/mlkem/native/aarch64/src/polyvec_basemul_acc_montgomery_cached_asm_k3.S mlkem-native_ml-kem-512_aarch64/mlkem/native/aarch64/src/polyvec_basemul_acc_montgomery_cached_asm_k4.S mlkem-native_ml-kem-512_aarch64/mlkem/native/aarch64/src/rej_uniform_asm.S mlkem-native_ml-kem-512_aarch64/mlkem/native/aarch64/src/rej_uniform_table.c mlkem-native_ml-kem-512_aarch64/mlkem/poly.c mlkem-native_ml-kem-512_aarch64/mlkem/poly_k.c mlkem-native_ml-kem-512_aarch64/mlkem/sampling.c mlkem-native_ml-kem-512_aarch64/mlkem/verify.c)
    target_include_directories(ml_kem_512_aarch64 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-512_aarch64)
    target_include_directories(ml_kem_512_aarch64 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_512_aarch64 PUBLIC -DMLKEM_K=2 -DMLK_CONFIG_FILE="../integration/liboqs/config_aarch64.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_512_aarch64>)
endif()

if(OQS_ENABLE_KEM_ml_kem_512_cuda)
    add_library(ml_kem_512_cuda OBJECT cupqc_ml-kem-512_cuda/cupqc_ml-kem.cu)
    target_link_libraries(ml_kem_512_cuda cupqc)
    set_property(TARGET ml_kem_512_cuda PROPERTY CUDA_ARCHITECTURES OFF)
    target_compile_options(ml_kem_512_cuda PRIVATE $<$<COMPILE_LANGUAGE:CUDA>:-rdc=true -dlto -arch=compute_70>)
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_512_cuda>)
endif()

if(OQS_ENABLE_KEM_ml_kem_768)
    add_library(ml_kem_768_ref OBJECT kem_ml_kem_768.c mlkem-native_ml-kem-768_ref/mlkem/compress.c mlkem-native_ml-kem-768_ref/mlkem/debug.c mlkem-native_ml-kem-768_ref/mlkem/indcpa.c mlkem-native_ml-kem-768_ref/mlkem/kem.c mlkem-native_ml-kem-768_ref/mlkem/poly.c mlkem-native_ml-kem-768_ref/mlkem/poly_k.c mlkem-native_ml-kem-768_ref/mlkem/sampling.c mlkem-native_ml-kem-768_ref/mlkem/verify.c)
    target_compile_options(ml_kem_768_ref PUBLIC -DMLKEM_K=3 -DMLK_CONFIG_FILE="../integration/liboqs/config_c.h")
    target_include_directories(ml_kem_768_ref PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-768_ref)
    target_include_directories(ml_kem_768_ref PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_768_ref PUBLIC -DMLKEM_K=3 -DMLK_CONFIG_FILE="../integration/liboqs/config_c.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_768_ref>)
endif()

if(OQS_ENABLE_KEM_ml_kem_768_x86_64)
    add_library(ml_kem_768_x86_64 OBJECT mlkem-native_ml-kem-768_x86_64/mlkem/compress.c mlkem-native_ml-kem-768_x86_64/mlkem/debug.c mlkem-native_ml-kem-768_x86_64/mlkem/indcpa.c mlkem-native_ml-kem-768_x86_64/mlkem/kem.c mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/basemul.c mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/basemul.S mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/compress_avx2.c mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/consts.c mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/intt.S mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/ntt.S mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/nttfrombytes.S mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/nttpack.S mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/ntttobytes.S mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/nttunpack.S mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/reduce.S mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/rej_uniform_avx2.c mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/rej_uniform_table.c mlkem-native_ml-kem-768_x86_64/mlkem/native/x86_64/src/tomont.S mlkem-native_ml-kem-768_x86_64/mlkem/poly.c mlkem-native_ml-kem-768_x86_64/mlkem/poly_k.c mlkem-native_ml-kem-768_x86_64/mlkem/sampling.c mlkem-native_ml-kem-768_x86_64/mlkem/verify.c)
    target_include_directories(ml_kem_768_x86_64 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-768_x86_64)
    target_include_directories(ml_kem_768_x86_64 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_768_x86_64 PRIVATE  -mavx2  -mbmi2  -mpopcnt )
    target_compile_options(ml_kem_768_x86_64 PUBLIC -DMLKEM_K=3 -DMLK_CONFIG_FILE="../integration/liboqs/config_x86_64.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_768_x86_64>)
endif()

if(OQS_ENABLE_KEM_ml_kem_768_aarch64)
    add_library(ml_kem_768_aarch64 OBJECT mlkem-native_ml-kem-768_aarch64/mlkem/compress.c mlkem-native_ml-kem-768_aarch64/mlkem/debug.c mlkem-native_ml-kem-768_aarch64/mlkem/indcpa.c mlkem-native_ml-kem-768_aarch64/mlkem/kem.c mlkem-native_ml-kem-768_aarch64/mlkem/native/aarch64/src/aarch64_zetas.c mlkem-native_ml-kem-768_aarch64/mlkem/native/aarch64/src/intt.S mlkem-native_ml-kem-768_aarch64/mlkem/native/aarch64/src/ntt.S mlkem-native_ml-kem-768_aarch64/mlkem/native/aarch64/src/poly_mulcache_compute_asm.S mlkem-native_ml-kem-768_aarch64/mlkem/native/aarch64/src/poly_reduce_asm.S mlkem-native_ml-kem-768_aarch64/mlkem/native/aarch64/src/poly_tobytes_asm.S mlkem-native_ml-kem-768_aarch64/mlkem/native/aarch64/src/poly_tomont_asm.S mlkem-native_ml-kem-768_aarch64/mlkem/native/aarch64/src/polyvec_basemul_acc_montgomery_cached_asm_k2.S mlkem-native_ml-kem-768_aarch64/mlkem/native/aarch64/src/polyvec_basemul_acc_montgomery_cached_asm_k3.S mlkem-native_ml-kem-768_aarch64/mlkem/native/aarch64/src/polyvec_basemul_acc_montgomery_cached_asm_k4.S mlkem-native_ml-kem-768_aarch64/mlkem/native/aarch64/src/rej_uniform_asm.S mlkem-native_ml-kem-768_aarch64/mlkem/native/aarch64/src/rej_uniform_table.c mlkem-native_ml-kem-768_aarch64/mlkem/poly.c mlkem-native_ml-kem-768_aarch64/mlkem/poly_k.c mlkem-native_ml-kem-768_aarch64/mlkem/sampling.c mlkem-native_ml-kem-768_aarch64/mlkem/verify.c)
    target_include_directories(ml_kem_768_aarch64 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-768_aarch64)
    target_include_directories(ml_kem_768_aarch64 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_768_aarch64 PUBLIC -DMLKEM_K=3 -DMLK_CONFIG_FILE="../integration/liboqs/config_aarch64.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_768_aarch64>)
endif()

if(OQS_ENABLE_KEM_ml_kem_768_cuda)
    add_library(ml_kem_768_cuda OBJECT cupqc_ml-kem-768_cuda/cupqc_ml-kem.cu)
    target_link_libraries(ml_kem_768_cuda cupqc)
    set_property(TARGET ml_kem_768_cuda PROPERTY CUDA_ARCHITECTURES OFF)
    target_compile_options(ml_kem_768_cuda PRIVATE $<$<COMPILE_LANGUAGE:CUDA>:-rdc=true -dlto -arch=compute_70>)
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_768_cuda>)
endif()

if(OQS_ENABLE_KEM_ml_kem_1024)
    add_library(ml_kem_1024_ref OBJECT kem_ml_kem_1024.c mlkem-native_ml-kem-1024_ref/mlkem/compress.c mlkem-native_ml-kem-1024_ref/mlkem/debug.c mlkem-native_ml-kem-1024_ref/mlkem/indcpa.c mlkem-native_ml-kem-1024_ref/mlkem/kem.c mlkem-native_ml-kem-1024_ref/mlkem/poly.c mlkem-native_ml-kem-1024_ref/mlkem/poly_k.c mlkem-native_ml-kem-1024_ref/mlkem/sampling.c mlkem-native_ml-kem-1024_ref/mlkem/verify.c)
    target_compile_options(ml_kem_1024_ref PUBLIC -DMLKEM_K=4 -DMLK_CONFIG_FILE="../integration/liboqs/config_c.h")
    target_include_directories(ml_kem_1024_ref PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-1024_ref)
    target_include_directories(ml_kem_1024_ref PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_1024_ref PUBLIC -DMLKEM_K=4 -DMLK_CONFIG_FILE="../integration/liboqs/config_c.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_1024_ref>)
endif()

if(OQS_ENABLE_KEM_ml_kem_1024_x86_64)

=== src/sig/mayo/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# This file was generated by
# scripts/copy_from_upstream/copy_from_upstream.py

set(_MAYO_OBJS "")

if(OQS_ENABLE_SIG_mayo_1)
    add_library(mayo_1_opt OBJECT sig_mayo_1.c pqmayo_mayo-1_opt/api.c pqmayo_mayo-1_opt/arithmetic.c pqmayo_mayo-1_opt/mayo.c pqmayo_mayo-1_opt/params.c)
    target_compile_options(mayo_1_opt PUBLIC -DMAYO_VARIANT=MAYO_1 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL -DHAVE_STACKEFFICIENT)
    target_include_directories(mayo_1_opt PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-1_opt)
    target_include_directories(mayo_1_opt PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_1_opt PUBLIC -DMAYO_VARIANT=MAYO_1 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL -DHAVE_STACKEFFICIENT)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_1_opt>)
endif()

if(OQS_ENABLE_SIG_mayo_1_avx2)
    add_library(mayo_1_avx2 OBJECT pqmayo_mayo-1_avx2/api.c pqmayo_mayo-1_avx2/arithmetic.c pqmayo_mayo-1_avx2/mayo.c pqmayo_mayo-1_avx2/params.c)
    target_include_directories(mayo_1_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-1_avx2)
    target_include_directories(mayo_1_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_1_avx2 PRIVATE -mavx2)
    target_compile_options(mayo_1_avx2 PUBLIC -DMAYO_VARIANT=MAYO_1 -DMAYO_BUILD_TYPE_AVX2 -DMAYO_AVX -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_1_avx2>)
endif()

if(OQS_ENABLE_SIG_mayo_1_neon)
    add_library(mayo_1_neon OBJECT pqmayo_mayo-1_neon/api.c pqmayo_mayo-1_neon/arithmetic.c pqmayo_mayo-1_neon/mayo.c pqmayo_mayo-1_neon/params.c)
    target_include_directories(mayo_1_neon PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-1_neon)
    target_include_directories(mayo_1_neon PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_1_neon PRIVATE)
    target_compile_options(mayo_1_neon PUBLIC -DMAYO_VARIANT=MAYO_1 -DMAYO_BUILD_TYPE_NEON -DMAYO_NEON -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_1_neon>)
endif()

if(OQS_ENABLE_SIG_mayo_2)
    add_library(mayo_2_opt OBJECT sig_mayo_2.c pqmayo_mayo-2_opt/api.c pqmayo_mayo-2_opt/arithmetic.c pqmayo_mayo-2_opt/mayo.c pqmayo_mayo-2_opt/params.c)
    target_compile_options(mayo_2_opt PUBLIC -DMAYO_VARIANT=MAYO_2 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL)
    target_include_directories(mayo_2_opt PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-2_opt)
    target_include_directories(mayo_2_opt PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_2_opt PUBLIC -DMAYO_VARIANT=MAYO_2 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_2_opt>)
endif()

if(OQS_ENABLE_SIG_mayo_2_avx2)
    add_library(mayo_2_avx2 OBJECT pqmayo_mayo-2_avx2/api.c pqmayo_mayo-2_avx2/arithmetic.c pqmayo_mayo-2_avx2/mayo.c pqmayo_mayo-2_avx2/params.c)
    target_include_directories(mayo_2_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-2_avx2)
    target_include_directories(mayo_2_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_2_avx2 PRIVATE -mavx2)
    target_compile_options(mayo_2_avx2 PUBLIC -DMAYO_VARIANT=MAYO_2 -DMAYO_BUILD_TYPE_AVX2 -DMAYO_AVX -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_2_avx2>)
endif()

if(OQS_ENABLE_SIG_mayo_2_neon)
    add_library(mayo_2_neon OBJECT pqmayo_mayo-2_neon/api.c pqmayo_mayo-2_neon/arithmetic.c pqmayo_mayo-2_neon/mayo.c pqmayo_mayo-2_neon/params.c)
    target_include_directories(mayo_2_neon PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-2_neon)
    target_include_directories(mayo_2_neon PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_2_neon PRIVATE)
    target_compile_options(mayo_2_neon PUBLIC -DMAYO_VARIANT=MAYO_2 -DMAYO_BUILD_TYPE_NEON -DMAYO_NEON -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_2_neon>)
endif()

if(OQS_ENABLE_SIG_mayo_3)
    add_library(mayo_3_opt OBJECT sig_mayo_3.c pqmayo_mayo-3_opt/api.c pqmayo_mayo-3_opt/arithmetic.c pqmayo_mayo-3_opt/mayo.c pqmayo_mayo-3_opt/params.c)
    target_compile_options(mayo_3_opt PUBLIC -DMAYO_VARIANT=MAYO_3 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL -DHAVE_STACKEFFICIENT)
    target_include_directories(mayo_3_opt PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-3_opt)
    target_include_directories(mayo_3_opt PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_3_opt PUBLIC -DMAYO_VARIANT=MAYO_3 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL -DHAVE_STACKEFFICIENT)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_3_opt>)
endif()

if(OQS_ENABLE_SIG_mayo_3_avx2)
    add_library(mayo_3_avx2 OBJECT pqmayo_mayo-3_avx2/api.c pqmayo_mayo-3_avx2/arithmetic.c pqmayo_mayo-3_avx2/mayo.c pqmayo_mayo-3_avx2/params.c)
    target_include_directories(mayo_3_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-3_avx2)
    target_include_directories(mayo_3_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_3_avx2 PRIVATE -mavx2)
    target_compile_options(mayo_3_avx2 PUBLIC -DMAYO_VARIANT=MAYO_3 -DMAYO_BUILD_TYPE_AVX2 -DMAYO_AVX -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_3_avx2>)
endif()

if(OQS_ENABLE_SIG_mayo_3_neon)
    add_library(mayo_3_neon OBJECT pqmayo_mayo-3_neon/api.c pqmayo_mayo-3_neon/arithmetic.c pqmayo_mayo-3_neon/mayo.c pqmayo_mayo-3_neon/params.c)
    target_include_directories(mayo_3_neon PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-3_neon)
    target_include_directories(mayo_3_neon PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_3_neon PRIVATE)
    target_compile_options(mayo_3_neon PUBLIC -DMAYO_VARIANT=MAYO_3 -DMAYO_BUILD_TYPE_NEON -DMAYO_NEON -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_3_neon>)
endif()

if(OQS_ENABLE_SIG_mayo_5)
    add_library(mayo_5_opt OBJECT sig_mayo_5.c pqmayo_mayo-5_opt/api.c pqmayo_mayo-5_opt/arithmetic.c pqmayo_mayo-5_opt/mayo.c pqmayo_mayo-5_opt/params.c)
    target_compile_options(mayo_5_opt PUBLIC -DMAYO_VARIANT=MAYO_5 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL -DHAVE_STACKEFFICIENT)
    target_include_directories(mayo_5_opt PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-5_opt)
    target_include_directories(mayo_5_opt PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_5_opt PUBLIC -DMAYO_VARIANT=MAYO_5 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL -DHAVE_STACKEFFICIENT)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_5_opt>)
endif()

if(OQS_ENABLE_SIG_mayo_5_avx2)
    add_library(mayo_5_avx2 OBJECT pqmayo_mayo-5_avx2/api.c pqmayo_mayo-5_avx2/arithmetic.c pqmayo_mayo-5_avx2/mayo.c pqmayo_mayo-5_avx2/params.c)
    target_include_directories(mayo_5_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-5_avx2)
    target_include_directories(mayo_5_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_5_avx2 PRIVATE -mavx2)
    target_compile_options(mayo_5_avx2 PUBLIC -DMAYO_VARIANT=MAYO_5 -DMAYO_BUILD_TYPE_AVX2 -DMAYO_AVX -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_5_avx2>)
endif()

if(OQS_ENABLE_SIG_mayo_5_neon)
    add_library(mayo_5_neon OBJECT pqmayo_mayo-5_neon/api.c pqmayo_mayo-5_neon/arithmetic.c pqmayo_mayo-5_neon/mayo.c pqmayo_mayo-5_neon/params.c)
    target_include_directories(mayo_5_neon PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-5_neon)
    target_include_directories(mayo_5_neon PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_5_neon PRIVATE)
    target_compile_options(mayo_5_neon PUBLIC -DMAYO_VARIANT=MAYO_5 -DMAYO_BUILD_TYPE_NEON -DMAYO_NEON -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_5_neon>)
endif()

set(MAYO_OBJS ${_MAYO_OBJS} PARENT_SCOPE)

=== src/sig/sphincs/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# This file was generated by
# scripts/copy_from_upstream/copy_from_upstream.py

set(_SPHINCS_OBJS "")

if(OQS_ENABLE_SIG_sphincs_sha2_128f_simple)
    add_library(sphincs_sha2_128f_simple_clean OBJECT sig_sphincs_sha2_128f_simple.c pqclean_sphincs-sha2-128f-simple_clean/address.c pqclean_sphincs-sha2-128f-simple_clean/context_sha2.c pqclean_sphincs-sha2-128f-simple_clean/fors.c pqclean_sphincs-sha2-128f-simple_clean/hash_sha2.c pqclean_sphincs-sha2-128f-simple_clean/merkle.c pqclean_sphincs-sha2-128f-simple_clean/sign.c pqclean_sphincs-sha2-128f-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-128f-simple_clean/utils.c pqclean_sphincs-sha2-128f-simple_clean/utilsx1.c pqclean_sphincs-sha2-128f-simple_clean/wots.c pqclean_sphincs-sha2-128f-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_128f_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-128f-simple_clean)
    target_include_directories(sphincs_sha2_128f_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_128f_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_128f_simple_avx2)
    add_library(sphincs_sha2_128f_simple_avx2 OBJECT pqclean_sphincs-sha2-128f-simple_avx2/address.c pqclean_sphincs-sha2-128f-simple_avx2/context_sha2.c pqclean_sphincs-sha2-128f-simple_avx2/fors.c pqclean_sphincs-sha2-128f-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-128f-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-128f-simple_avx2/merkle.c pqclean_sphincs-sha2-128f-simple_avx2/sha256avx.c pqclean_sphincs-sha2-128f-simple_avx2/sha256x8.c pqclean_sphincs-sha2-128f-simple_avx2/sign.c pqclean_sphincs-sha2-128f-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-128f-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-128f-simple_avx2/utils.c pqclean_sphincs-sha2-128f-simple_avx2/utilsx8.c pqclean_sphincs-sha2-128f-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_128f_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-128f-simple_avx2)
    target_include_directories(sphincs_sha2_128f_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_128f_simple_avx2 PRIVATE -mavx2)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_128f_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_128s_simple)
    add_library(sphincs_sha2_128s_simple_clean OBJECT sig_sphincs_sha2_128s_simple.c pqclean_sphincs-sha2-128s-simple_clean/address.c pqclean_sphincs-sha2-128s-simple_clean/context_sha2.c pqclean_sphincs-sha2-128s-simple_clean/fors.c pqclean_sphincs-sha2-128s-simple_clean/hash_sha2.c pqclean_sphincs-sha2-128s-simple_clean/merkle.c pqclean_sphincs-sha2-128s-simple_clean/sign.c pqclean_sphincs-sha2-128s-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-128s-simple_clean/utils.c pqclean_sphincs-sha2-128s-simple_clean/utilsx1.c pqclean_sphincs-sha2-128s-simple_clean/wots.c pqclean_sphincs-sha2-128s-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_128s_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-128s-simple_clean)
    target_include_directories(sphincs_sha2_128s_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_128s_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_128s_simple_avx2)
    add_library(sphincs_sha2_128s_simple_avx2 OBJECT pqclean_sphincs-sha2-128s-simple_avx2/address.c pqclean_sphincs-sha2-128s-simple_avx2/context_sha2.c pqclean_sphincs-sha2-128s-simple_avx2/fors.c pqclean_sphincs-sha2-128s-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-128s-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-128s-simple_avx2/merkle.c pqclean_sphincs-sha2-128s-simple_avx2/sha256avx.c pqclean_sphincs-sha2-128s-simple_avx2/sha256x8.c pqclean_sphincs-sha2-128s-simple_avx2/sign.c pqclean_sphincs-sha2-128s-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-128s-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-128s-simple_avx2/utils.c pqclean_sphincs-sha2-128s-simple_avx2/utilsx8.c pqclean_sphincs-sha2-128s-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_128s_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-128s-simple_avx2)
    target_include_directories(sphincs_sha2_128s_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_128s_simple_avx2 PRIVATE -mavx2)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_128s_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_192f_simple)
    add_library(sphincs_sha2_192f_simple_clean OBJECT sig_sphincs_sha2_192f_simple.c pqclean_sphincs-sha2-192f-simple_clean/address.c pqclean_sphincs-sha2-192f-simple_clean/context_sha2.c pqclean_sphincs-sha2-192f-simple_clean/fors.c pqclean_sphincs-sha2-192f-simple_clean/hash_sha2.c pqclean_sphincs-sha2-192f-simple_clean/merkle.c pqclean_sphincs-sha2-192f-simple_clean/sign.c pqclean_sphincs-sha2-192f-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-192f-simple_clean/utils.c pqclean_sphincs-sha2-192f-simple_clean/utilsx1.c pqclean_sphincs-sha2-192f-simple_clean/wots.c pqclean_sphincs-sha2-192f-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_192f_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-192f-simple_clean)
    target_include_directories(sphincs_sha2_192f_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_192f_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_192f_simple_avx2)
    add_library(sphincs_sha2_192f_simple_avx2 OBJECT pqclean_sphincs-sha2-192f-simple_avx2/address.c pqclean_sphincs-sha2-192f-simple_avx2/context_sha2.c pqclean_sphincs-sha2-192f-simple_avx2/fors.c pqclean_sphincs-sha2-192f-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-192f-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-192f-simple_avx2/merkle.c pqclean_sphincs-sha2-192f-simple_avx2/sha256avx.c pqclean_sphincs-sha2-192f-simple_avx2/sha256x8.c pqclean_sphincs-sha2-192f-simple_avx2/sha512x4.c pqclean_sphincs-sha2-192f-simple_avx2/sign.c pqclean_sphincs-sha2-192f-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-192f-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-192f-simple_avx2/utils.c pqclean_sphincs-sha2-192f-simple_avx2/utilsx8.c pqclean_sphincs-sha2-192f-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_192f_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-192f-simple_avx2)
    target_include_directories(sphincs_sha2_192f_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_192f_simple_avx2 PRIVATE -mavx2)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_192f_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_192s_simple)
    add_library(sphincs_sha2_192s_simple_clean OBJECT sig_sphincs_sha2_192s_simple.c pqclean_sphincs-sha2-192s-simple_clean/address.c pqclean_sphincs-sha2-192s-simple_clean/context_sha2.c pqclean_sphincs-sha2-192s-simple_clean/fors.c pqclean_sphincs-sha2-192s-simple_clean/hash_sha2.c pqclean_sphincs-sha2-192s-simple_clean/merkle.c pqclean_sphincs-sha2-192s-simple_clean/sign.c pqclean_sphincs-sha2-192s-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-192s-simple_clean/utils.c pqclean_sphincs-sha2-192s-simple_clean/utilsx1.c pqclean_sphincs-sha2-192s-simple_clean/wots.c pqclean_sphincs-sha2-192s-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_192s_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-192s-simple_clean)
    target_include_directories(sphincs_sha2_192s_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_192s_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_192s_simple_avx2)
    add_library(sphincs_sha2_192s_simple_avx2 OBJECT pqclean_sphincs-sha2-192s-simple_avx2/address.c pqclean_sphincs-sha2-192s-simple_avx2/context_sha2.c pqclean_sphincs-sha2-192s-simple_avx2/fors.c pqclean_sphincs-sha2-192s-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-192s-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-192s-simple_avx2/merkle.c pqclean_sphincs-sha2-192s-simple_avx2/sha256avx.c pqclean_sphincs-sha2-192s-simple_avx2/sha256x8.c pqclean_sphincs-sha2-192s-simple_avx2/sha512x4.c pqclean_sphincs-sha2-192s-simple_avx2/sign.c pqclean_sphincs-sha2-192s-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-192s-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-192s-simple_avx2/utils.c pqclean_sphincs-sha2-192s-simple_avx2/utilsx8.c pqclean_sphincs-sha2-192s-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_192s_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-192s-simple_avx2)
    target_include_directories(sphincs_sha2_192s_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_192s_simple_avx2 PRIVATE -mavx2)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_192s_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_256f_simple)
    add_library(sphincs_sha2_256f_simple_clean OBJECT sig_sphincs_sha2_256f_simple.c pqclean_sphincs-sha2-256f-simple_clean/address.c pqclean_sphincs-sha2-256f-simple_clean/context_sha2.c pqclean_sphincs-sha2-256f-simple_clean/fors.c pqclean_sphincs-sha2-256f-simple_clean/hash_sha2.c pqclean_sphincs-sha2-256f-simple_clean/merkle.c pqclean_sphincs-sha2-256f-simple_clean/sign.c pqclean_sphincs-sha2-256f-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-256f-simple_clean/utils.c pqclean_sphincs-sha2-256f-simple_clean/utilsx1.c pqclean_sphincs-sha2-256f-simple_clean/wots.c pqclean_sphincs-sha2-256f-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_256f_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-256f-simple_clean)
    target_include_directories(sphincs_sha2_256f_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_256f_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_256f_simple_avx2)
    add_library(sphincs_sha2_256f_simple_avx2 OBJECT pqclean_sphincs-sha2-256f-simple_avx2/address.c pqclean_sphincs-sha2-256f-simple_avx2/context_sha2.c pqclean_sphincs-sha2-256f-simple_avx2/fors.c pqclean_sphincs-sha2-256f-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-256f-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-256f-simple_avx2/merkle.c pqclean_sphincs-sha2-256f-simple_avx2/sha256avx.c pqclean_sphincs-sha2-256f-simple_avx2/sha256x8.c pqclean_sphincs-sha2-256f-simple_avx2/sha512x4.c pqclean_sphincs-sha2-256f-simple_avx2/sign.c pqclean_sphincs-sha2-256f-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-256f-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-256f-simple_avx2/utils.c pqclean_sphincs-sha2-256f-simple_avx2/utilsx8.c pqclean_sphincs-sha2-256f-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_256f_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-256f-simple_avx2)
    target_include_directories(sphincs_sha2_256f_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_256f_simple_avx2 PRIVATE -mavx2)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_256f_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_256s_simple)

=== src/sig_stfl/lms/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

set(_LMS_OBJS "")

set(SRCS
         external/endian.c
         external/hash.c
         external/hss.c
         external/hss_alloc.c
         external/hss_aux.c
         external/hss_common.c
         external/hss_compute.c
         external/hss_derive.c
         external/hss_generate.c
         external/hss_keygen.c
         external/hss_param.c
         external/hss_reserve.c
         external/hss_sign.c
         external/hss_sign_inc.c
         external/hss_thread_single.c
         external/hss_verify.c
         external/hss_verify_inc.c
         external/hss_zeroize.c
         external/lm_common.c
         external/lm_ots_common.c
         external/lm_ots_sign.c
         external/lm_ots_verify.c
         external/lm_verify.c
         sig_stfl_lms.c
         sig_stfl_lms_functions.c
   )
    
#if (OQS_ENABLE_SIG_STFL_lms)
#    add_compile_definitions(OQS_ENABLE_SIG_STFL_lms)
#    set (SRCS ${SRCS} sig_stfl_lms.c sig_stfl_lms_functions.c)
#endif()


add_library(lms OBJECT ${SRCS})
target_include_directories(lms PRIVATE ${LIBOQS_ROOT_DIR}/include)
set(_LMS_OBJS ${_LMS_OBJS} $<TARGET_OBJECTS:lms>)
set(LMS_OBJS ${_LMS_OBJS} PARENT_SCOPE)

=== scripts/copy_from_upstream/src/kem/family/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# This file was generated by
# scripts/copy_from_upstream/copy_from_upstream.py

set(_{{ family|upper }}_OBJS "")

{%- if common_deps is defined %}
    {%- for common_dep in common_deps %}

if({% for used_by in common_deps_usedby[common_dep['name']] -%}OQS_ENABLE_KEM_{{ family }}_{{ used_by['scheme_c'] }}{%- if used_by['impl_name'] != default_implementation %}_{{ used_by['impl_name'] }}{% endif -%}{%- if not loop.last %} OR {% endif -%}{%- endfor -%})
    add_library({{ family }}_{{ common_dep['name'] }} OBJECT {% for source_file in common_dep['sources_addl']|sort -%}{{ upstream_location }}_{{ common_dep['name'] }}/{{ source_file }}{%- if not loop.last %} {% endif -%}{%- endfor -%})
    target_include_directories({{ family }}_{{ common_dep['name'] }} PRIVATE ${CMAKE_CURRENT_LIST_DIR}/{{ upstream_location }}_{{ common_dep['name'] }})
        {%- if common_dep['required_flags'] %}
    target_compile_options({{ family }}_{{ common_dep['name'] }} PRIVATE {%- for flag in common_dep['required_flags'] %}{%- if flag != 'arm_neon' %} -m{%- if flag == 'bmi1' -%} bmi {%- elif flag == 'sse4_1' -%} sse4.1 {%- elif flag == 'pclmulqdq' -%} pclmul {%- else -%}{{ flag }}{%- endif -%}{%- endif -%}{%- endfor -%})
        {%- endif %}
        {%- if common_dep['compile_opts'] %}
    target_compile_options({{ family }}_{{ common_dep['name'] }} PUBLIC {{ common_dep['compile_opts'] }})
        {%- endif %}
    set(_{{ family|upper }}_OBJS ${_{{ family|upper }}_OBJS} $<TARGET_OBJECTS:{{ family }}_{{ common_dep['name'] }}>)
endif()

    {%- endfor %}
{%- endif %}

{%- for scheme in schemes -%}
    {%- for impl in scheme['metadata']['implementations'] -%}
        {%- if impl['name'] == scheme['default_implementation'] %}

if(OQS_ENABLE_KEM_{{ family }}_{{ scheme['scheme_c'] }}{%- if 'alias_scheme' in scheme %} OR OQS_ENABLE_KEM_{{ family }}_{{ scheme['alias_scheme'] }}{%- endif %})
    add_library({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} OBJECT kem_{{ family }}_{{ scheme['scheme'] }}.c {% for source_file in impl['sources']|sort -%}{{ impl['upstream']['name'] }}_{{ scheme['pqclean_scheme'] }}_{{ impl['name'] }}/{{ source_file }}{%- if not loop.last %} {% endif -%}{%- endfor -%})
           {%- if impl['compile_opts'] %}
    target_compile_options({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PUBLIC {{ impl['compile_opts'] }})
           {%- endif -%}

        {%- elif impl['name'] == 'cuda' %}

if(OQS_ENABLE_KEM_{{ family }}_{{ scheme['scheme_c'] }}_{{ impl['name'] }}{%- if 'alias_scheme' in scheme %} OR OQS_ENABLE_KEM_{{ family }}_{{ scheme['alias_scheme'] }}_{{ impl['name'] }}{%- endif %})
    add_library({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} OBJECT {{ impl['upstream']['name'] }}_{{ scheme['pqclean_scheme'] }}_{{ impl['name'] }}/cupqc_ml-kem.cu)
    target_link_libraries({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} cupqc)
    set_property(TARGET {{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PROPERTY CUDA_ARCHITECTURES OFF)
    target_compile_options({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE {{ impl['compile_opts'] }})
        {%- else %}

if(OQS_ENABLE_KEM_{{ family }}_{{ scheme['scheme_c'] }}_{{ impl['name'] }}{%- if 'alias_scheme' in scheme %} OR OQS_ENABLE_KEM_{{ family }}_{{ scheme['alias_scheme'] }}_{{ impl['name'] }}{%- endif %})
    add_library({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} OBJECT {% for source_file in impl['sources']|sort -%}{{ impl['upstream']['name'] }}_{{ scheme['pqclean_scheme'] }}_{{ impl['name'] }}/{{ source_file }}{%- if not loop.last %} {% endif -%}{%- endfor -%})
        {%- endif %}
        {%- if impl['name'] != 'cuda' %}
    target_include_directories({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE ${CMAKE_CURRENT_LIST_DIR}/{{ impl['upstream']['name'] }}_{{ scheme['pqclean_scheme'] }}_{{ impl['name'] }})
    target_include_directories({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
        {%- if impl['name'] != scheme['default_implementation'] and impl['required_flags'] -%}
           {%- set opts %}{% for flag in impl['required_flags'] %}{%- if flag != 'arm_neon' %} -m{%- if flag == 'bmi1' -%} bmi {% elif flag == 'sse4_1' -%} sse4.1 {% elif flag == 'pclmulqdq' -%} pclmul {% else -%}{{ flag }} {% endif %}{% endif -%}{% endfor %}{% endset %}
           {%- if opts|length > 0 %}
    target_compile_options({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE {{ opts }})
           {%- endif -%}
        {%- endif %}
        {%- if impl['compile_opts'] %}
    target_compile_options({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PUBLIC {{ impl['compile_opts'] }})
        {%- endif %}
        {%- if family == 'classic_mceliece' and impl['name'] == 'avx2' %}
    target_compile_options({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE -Wno-language-extension-token -O1)
        {%- endif %}
        {%- if family == 'hqc' and impl['name'] == 'avx2' %}
    target_compile_options({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE -Wno-missing-braces)
        {%- endif %}
        {%- if impl['upstream']['name'].endswith('pqclean') %}
    if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
        target_compile_definitions({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE old_gas_syntax)
    endif()
    	{%- endif %}
        {%- endif %}{# cupqc #}
    set(_{{ family|upper }}_OBJS ${_{{ family|upper }}_OBJS} $<TARGET_OBJECTS:{{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }}>)
endif()
    {%- endfor -%}
{%- endfor %}

{% if libjade_implementation is defined -%}
##### OQS_COPY_FROM_LIBJADE_FRAGMENT_CMAKELISTS_START

##### OQS_COPY_FROM_LIBJADE_FRAGMENT_CMAKELISTS_END
{% endif -%}

set({{ family|upper }}_OBJS ${_{{ family|upper }}_OBJS} PARENT_SCOPE)

=== PKGBUILD ===
# Maintainer: d0p1 <contact@d0p1.eu>

_realname=liboqs
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.13.0
pkgrel=1
pkgdesc="C library for prototyping and experimenting with quantum-resistant cryptography (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://openquantumsafe.org/'
msys2_repository_url="https://github.com/open-quantum-safe/liboqs"
license=('spdx:MIT')
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-cc"
)
checkdepends=(
  "${MINGW_PACKAGE_PREFIX}-python-pytest"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-xdist"
  "${MINGW_PACKAGE_PREFIX}-python-yaml"
)
source=("https://github.com/open-quantum-safe/liboqs/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "001-aarch64-detection.patch")
sha256sums=('789e9b56bcb6b582467ccaf5cdb5ab85236b0c1007d30c606798fa8905152887'
            '99a7133701b106e6e0d4d9dece250a2e63c1082c7c6835747ad69387bd29f958')

apply_patch_with_msg() {
  for _fname in "$@"
  do
    msg2 "Applying ${_fname}"
    patch -Nbp1 -i "${srcdir}"/${_fname}
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  apply_patch_with_msg \
    001-aarch64-detection.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CC} == clang ]]; then
    export CFLAGS+=" -Wno-unknown-warning-option"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DBUILD_SHARED_LIBS=ON \
      -DOQS_BUILD_ONLY_LIB=ON \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
